#include <bits/stdc++.h>
using namespace std;

int main(){
    int N,Q,x,y,dmg=0,dmg1=0;  cin >> N >> Q;
    vector<int>D; vector<int>H; vector<int>resenja;
    for(int i=0; i<N/2;i++){
        cin >> x >> y;
        D.push_back(x);
        dmg+=x;
        dmg1+=x;
    }
    for(int i=N/2; i<N;i++){
        cin >> x >> y;
        D.push_back(x);
        dmg+=x;
    }
    for(int i=0;i<Q;i++){
        cin >> x;
        H.push_back(x);
    }
    for(int i=0; i<H.size();i++){
            if(dmg < H[i]){
                resenja.push_back(-1);
            }else if(H[i]>dmg1){
                H[i]-=dmg1;
                for(int j=N/2;i<N;j++){
                    H[i]-=D[j];
                    if(H[i]<=0){
                        resenja.push_back(j+1);
                        break;
                    }
                }
            }else{
                for(int j=0;j<N;j++){
                    H[i]-=D[j];
                    if(H[i]<=0){
                        resenja.push_back(j+1);
                        break;
                    }
                }
            }
    }
    for(auto x: resenja){
        cout << x << endl;
    }
}